/**
 * Realizza il lato in delle comunicazioni via pipe,
 * nel caso inter-process, tramite un file condiviso.
 * I dati scambiati sono date (PersistentTime).
 * 
 * @author (C. Montangero) 
 * @version (1.2)
 */
 import java.io.ObjectInputStream;
 import java.io.FileInputStream;
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
 import java.io.IOException;
 import java.io.FileNotFoundException;
 import java.util.Calendar;
 
public class DriverIn implements IPipeIn {
    ObjectInputStream driverIn = null;
   
    /**
     * Constructor for objects of class DriverIn
     */
    public DriverIn(String filename) {
        FileInputStream fis = null;
        while (fis == null) { // busy waiting se il file non esiste: DriverOut lo deve creare
         try {fis = new FileInputStream(filename);
           }
           catch(FileNotFoundException ex)  // traccia
           {System.out.println("attesaIn");
               try {Thread.sleep(6000);
                }
                catch(InterruptedException exFNF1)
                {};
           }
        }
        try {
            driverIn = new ObjectInputStream(fis);
        } catch(IOException ex) {
            ex.printStackTrace();
        }
   }

    /**
     * Realizza l'operazione di estrazione dalla pipe, leggendo dal file.
     * Busy waiting in caso di pipe vuota.
     * 
     * @return : il valore estratto.
     */
    public PersistentTime in() {
        PersistentTime time = null;
        try { while (time == null) {
                 try {time = (PersistentTime) driverIn.readObject();
                 } catch(java.io.EOFException ex) // pipe vuota
                 { System.out.println("attesaIn");
                   try {Thread.sleep(6000);
                   } catch(InterruptedException exint2)
                   {}
                 }
            }
        } catch(IOException ex)
        { ex.printStackTrace();
        } catch(ClassNotFoundException ex)
        { ex.printStackTrace();
        }
        return time;
    }
    
    /**
     * Chiude il file, per una fine ordinata.
     * 
     */    
    public void close() {
        try { driverIn.close();
        } catch(IOException ex)
        { ex.printStackTrace();
        }
    }     
}
