 import java.io.ObjectOutputStream;
 import java.io.FileOutputStream;
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
 import java.io.IOException;
/**
 * Realizza il lato out delle comunicazioni via pipe,
 * nel caso inter-process, tramite un file condiviso.
 * I dati scambiati sono date (PersistentTime).
 * 
 * @author (C. Montangero) 
 * @version (1.2)
 */
public class DriverOut implements IPipeOut{
    ObjectOutputStream out = null;
  
    /**
     * Constructor for objects of class DriverOut
     */
    public DriverOut(String filename) {
       FileOutputStream fos = null;
       try {
           fos = new FileOutputStream(filename); //crea il file, se non esiste gi
           out = new ObjectOutputStream(fos);
        } catch(IOException ex)
        { ex.printStackTrace();
        } 
    }

    /**
     * Realizza l'operazione di inserzione nella pipe, scrivendo sul file.
     * 
     * @arg time : il valore scritto.
     */
    public void out(PersistentTime time) {
        try { 
            out.writeObject(time);
        } catch(IOException ex)
        { ex.printStackTrace();
        } 
    }
    
    /**
     * Chiude il file, per una fine ordinata.
     * 
     */
    public void close() {
        try {
            out.close();
        } catch(IOException ex)
        { ex.printStackTrace();
        }
    }
}