/**
 * Simula il comportamento di una componente che immette dati in una pipe.
 * Va lanciato in una shell, diversa da quella dove viene lanciato il corrispondente
 * DriverIn.
 * Per ogni dato inserito, stampa il dato e l'ora di inserzione, e chiede
 * conferma per proseguire (<CR> per continuare, "no" per terminare).
 * 
 * @author (C. Montangero) 
 * @version (1.2)
 */
 import java.io.ObjectOutputStream;
 import java.util.Calendar;
 import java.io.FileOutputStream;
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
 import java.io.IOException;
 
 public class FlattenTime  {
 public static void main(String [] args) {
     
  String filename = "time.ser"; //nome convenzionale
  IPipeOut driverOut = new DriverOut(filename); 
  
  // Per controllare da console l'inserimento dei dati
  BufferedReader interact = new BufferedReader(new InputStreamReader(System.in));
  String input = "";
  
  while (input.equals("")) {
    PersistentTime time = new PersistentTime();
    driverOut.out(time);
    
    //traccia
    System.out.println("Flattened time: " + time.getTime()); 
    System.out.println("Current time: " + Calendar.getInstance().getTime()); 
    
    // controllo del ciclo
    System.out.println("Go?"); //rispondere "no" per terminare
    try {input = interact.readLine();
    } catch(IOException ex)
    { ex.printStackTrace();
    }
  }
  
  driverOut.close();
 }
}