/**
 * Simula il comportamento di una componente che estrae dati da una pipe.
 * Va lanciato in una shell, diversa da quella dove viene lanciato il corrispondente
 * DriverOut.
 * Per ogni dato estratto, stampa il dato e l'ora di estrazione, e chiede
 * conferma per proseguire (<CR> per continuare, "no" per terminare).
 * 
 * @author (C. Montangero) 
 * @version (1.2)
 */
 import java.io.ObjectInputStream;
 import java.io.FileInputStream;
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
 import java.io.IOException;
 import java.io.FileNotFoundException;
 import java.util.Calendar;

 public class InflateTime {
  public static void main(String [] args) {
   
   String filename = "time.ser";  // nome convenzionale
   IPipeIn driverIn = new DriverIn(filename);
   
   // Per controllare da console l'estrazione dei dati
   BufferedReader interact = new BufferedReader(new InputStreamReader(System.in));
   String input = "";

   while (input.equals("")) {
    PersistentTime time = driverIn.in();
    
    // traccia
    System.out.println("Flattened time: " + time.getTime());
    System.out.println("Current time: " + Calendar.getInstance().getTime());
    
    // controllo del ciclo
    System.out.println("Go?"); //rispondere "no" per terminare
     try { input = interact.readLine();
     } catch(IOException ex)
     { ex.printStackTrace();
     }
   }
   
   driverIn.close();
  }
}